#ifndef IMAGE_H
#define IMAGE_H
#include "struct.h"

class Image
{
public:
	//캯
	Image(){}//жΪImage
	Image(int h, int w);//hУwеImage
	Image(int h, int w, unsigned char val); //ͼֵΪval;
	Image(const char* ImageName); //ļӲ̼ͼļΪImage;
	Image(unsigned char *m, int rows, int cols); //һά̬鴴Imageͼɺ;
	Image(unsigned char m[][100], int rows); //Ӿ̬ά鴴Imageͼάĵһάȣɵڶrows;
	Image(unsigned char **m, int h, int w); //Ӷ̬飨ָ룩Imageͼɺ;
	Image(Image &im); //캯;
	~Image(); //;


	void ReadBMP(const char* filename); //BMPļжͼ;
	void WriteBMP(const char* filename); //ͼݱΪBMPͼļ;
	void WriteBMP(const char *filename, unsigned char** data);//תʱдͼƬ
	void WriteBMP(const char *filename, unsigned char** data,//ʱдͼƬ
		BMPFILEHEADER bmpfileheader, BITMAPINFOHEADER bitmapinfoheader);


	void ReadText(const char* filename); //ıļжͼ;
	void WriteText(const char* filename); //ͼݱΪıļ;


	unsigned char& At(int row, int col); //ȡrowеcolеصֵ;
	void Set(int row, int col, unsigned char value); //(row,col)Ϊĳֵ;
	void Set(unsigned char value); //ͼΪͬһֵ;


	void Flip(int code); //ͼķת; codeֵ0:ҷת1:·ת;
	void Resize(int code); //ͼ;codeֵ0:Сһ1:Ŵһ;


	void Cut(int x1, int y1, int x2, int y2);//ü(x1,y1)(x2,y2)ͼ


	void Rotate(int degree);//ͼתĺתǶΪ90ȵ


	void Mean_Variance(float &m, float &var);//ͼľֵͷò

	friend void Swap(Image &a, Image &b);//ʹԪImage
	void myFree(unsigned char** data, int h);
	Image& operator=(Image& val);//ز

private:
	unsigned char **data;
	int height;
	int width;
	BMPFILEHEADER bmpfileheader;
	BITMAPINFOHEADER bitmapinfoheader;
};

#endif
