#include "image.h"
#include <cstdio>
#include <cstdlib>
#include <string>
#include <cstring>
using namespace std;
//ͨ캯
Image::Image(int h, int w) :height(h), width(w)
{
	this->height = h;
	this->width = w;
	// ̬ά洢ݣעһָ飬
	data = (unsigned char **)malloc(sizeof(unsigned char*) * this->height);
	//СΪsizeof(unsigned char*) * bitmapinfoheader.biHeight״
	//ָ
	for (int i = 0; i < this->height; i++)
	{
		//ע3ͨÿ3ֽ
		data[i] = (unsigned char *)malloc(this->width * 3);
		// ȡ
		for (int j = 0; j < this->width; j++)
		{
			data[i][j] = 0;
		}
	}
}
Image::Image(int h, int w, unsigned char val)//ͼֵΪval;
{
	this->height = h;
	this->width = w;
	// ̬ά洢ݣעһָ飬
	data = (unsigned char **)malloc(sizeof(unsigned char*) * this->height);
	//СΪsizeof(unsigned char*) * bitmapinfoheader.biHeight״
	//ָ
	for (int i = 0; i < this->height; i++)
	{
		//ע3ͨÿ3ֽ
		data[i] = (unsigned char *)malloc(this->width * 3);
		// ȡ
		for (int j = 0; j < this->width; j++)
		{
			data[i][j] = val;
		}
	}
}
Image::Image(const char* ImageName)//ļӲ̼ͼļΪImage;
{
	this->ReadBMP(ImageName);
}
Image::Image(unsigned char *m, int rows, int cols)//һά̬鴴Imageͼɺ;
{
	this->height = rows;
	this->width = cols;
	// ̬ά洢ݣעһָ飬
	data = (unsigned char **)malloc(sizeof(unsigned char*) * this->height);
	//СΪsizeof(unsigned char*) * bitmapinfoheader.biHeight״
	//ָ
	for (int i = 0; i < this->height; i++)
	{
		//ע3ͨÿ3ֽ
		data[i] = (unsigned char *)malloc(this->width * 3);
		// ȡ
		for (int j = 0; j < this->width; j++)
		{
			data[i][j] = *m;
			m++;
		}
	}
}
Image::Image(unsigned char m[][100], int rows)//Ӿ̬ά鴴Imageͼάĵһάȣɵڶrows;
{
	this->height = rows;
	this->width = 100;
	// ̬ά洢ݣעһָ飬
	data = (unsigned char **)malloc(sizeof(unsigned char*) * this->height);
	//СΪsizeof(unsigned char*) * bitmapinfoheader.biHeight״
	//ָ
	for (int i = 0; i < this->height; i++)
	{
		//ע3ͨÿ3ֽ
		data[i] = (unsigned char *)malloc(this->width * 3);
		// ȡ
		for (int j = 0; j < this->width; j++)
		{
			data[i][j] = m[i][j];
		}
	}
}
Image::Image(unsigned char **m, int h, int w)//Ӷ̬飨ָ룩Imageͼɺ;
{
	this->height = h;
	this->width = w;
	// ̬ά洢ݣעһָ飬
	data = (unsigned char **)malloc(sizeof(unsigned char*) * this->height);
	//СΪsizeof(unsigned char*) * bitmapinfoheader.biHeight״
	//ָ
	for (int i = 0; i < this->height; i++)
	{
		//ע3ͨÿ3ֽ
		data[i] = (unsigned char *)malloc(this->width * 3);
		// ȡ
		for (int j = 0; j < this->width; j++)
		{
			data[i][j] = m[i][j];
		}
	}
}
//캯
Image::Image(Image &im)
{
	if (this->data)
	{
		delete[] this->data;
		this->data = NULL;
	}

	*this = im;
}


//ͷŶ
void Image::myFree(unsigned char** data, int h)
{
	for (int i = 0; i < h; i++)
	{
		free(data[i]);
		data[i] = NULL;
	}
	free(data);
	data = NULL;
	puts("ͷŶ");
}
//
Image::~Image()
{
	this->myFree(this->data, this->height);
}


//Ӳ̶ͼļ洢image
void Image::ReadBMP(const char* filename)
{
	FILE* fp = NULL;  // C׼ļָ
    fp = fopen(filename, "rb"); // ƶȡʽļ

	// ȡļͷ
	fread(&bmpfileheader, sizeof(bmpfileheader), 1, fp);
	// ȡϢͷ
	fread(&bitmapinfoheader, sizeof(bitmapinfoheader), 1, fp);

	// ̬ά洢ݣעһָ飬
	data = (unsigned char **)malloc(sizeof(unsigned char*) * bitmapinfoheader.biHeight);
	//СΪsizeof(unsigned char*) * bitmapinfoheader.biHeight״
	//ָ
	for (int i = 0; i < bitmapinfoheader.biHeight; i++)
	{
		//ע3ͨÿ3ֽ
		data[i] = (unsigned char *)malloc(bitmapinfoheader.biWidth * 3);
		// ȡ
		for (int j = 0; j < bitmapinfoheader.biWidth * 3; j++)
		{
			fread(&data[i][j], 1, 1, fp);
		}
	}
	this->height = this->bitmapinfoheader.biHeight;
	this->width = this->bitmapinfoheader.biWidth;
	printf("height = %d width = %d\n",this->height,this->width);

	// رնȡļ
	fclose(fp);
}


//bmpͼ
void Image::WriteBMP(const char *filename)
{
	FILE* fp = NULL; // ļļָ
	fp = fopen(filename, "wb"); // д뷽ʽļ
	// дļͷ
	fwrite(&bmpfileheader, sizeof(bmpfileheader), 1, fp);
	// дϢͷ
	fwrite(&bitmapinfoheader, sizeof(bitmapinfoheader), 1, fp);
	// д
	for (int i = 0; i < bitmapinfoheader.biHeight; i++)
	{
		fwrite(data[i], bitmapinfoheader.biWidth * 3, 1, fp);
	}
	// رдļ
	fclose(fp);
}
//bmpͼ
void Image::WriteBMP(const char *filename, unsigned char** data)
{
	FILE* fp = NULL; // ļļָ
	fp = fopen(filename, "wb"); // д뷽ʽļ
	// дļͷ
	fwrite(&bmpfileheader, sizeof(bmpfileheader), 1, fp);
	// дϢͷ
	fwrite(&bitmapinfoheader, sizeof(bitmapinfoheader), 1, fp);
	// д
	for (int i = 0; i < bitmapinfoheader.biHeight; i++)
	{
		fwrite(data[i], bitmapinfoheader.biWidth * 3, 1, fp);
	}
	// رдļ
	fclose(fp);
}
//bmpͼ
void Image::WriteBMP(const char *filename, unsigned char** t_data, 
	BMPFILEHEADER bmpfileheader, BITMAPINFOHEADER t_bitmapinfoheader)
{
	FILE* fp = NULL; // ļļָ
	fp = fopen(filename, "wb"); // д뷽ʽļ
	// дļͷ
	fwrite(&bmpfileheader, sizeof(bmpfileheader), 1, fp);
	// дϢͷ
	fwrite(&t_bitmapinfoheader, sizeof(t_bitmapinfoheader), 1, fp);
	// д
	for (int i = 0; i < t_bitmapinfoheader.biHeight; i++)
	{
		fwrite(t_data[i], t_bitmapinfoheader.biWidth * 3, 1, fp);
	}
	// رдļ
	fclose(fp);
}


//ıļȡ
void Image::ReadText(const char* filename)
{
	FILE* fp = NULL;  // C׼ļָ
	fp = fopen(filename, "rb"); // ƶȡʽļ

	fread(&bitmapinfoheader.biHeight, sizeof(bitmapinfoheader.biHeight), 1, fp);
	fread(&bitmapinfoheader.biWidth, sizeof(bitmapinfoheader.biWidth), 1, fp);

	// ̬ά洢ݣעһָ飬
	data = (unsigned char **)malloc(sizeof(unsigned char*) * bitmapinfoheader.biHeight);
	//СΪsizeof(unsigned char*) * bitmapinfoheader.biHeight״
	//ָ
	for (int i = 0; i < bitmapinfoheader.biHeight; i++)
	{
		//ע3ͨÿ3ֽ
		data[i] = (unsigned char *)malloc(bitmapinfoheader.biWidth * 3);
		// ȡ
		for (int j = 0; j < bitmapinfoheader.biWidth * 3; j++)
		{
			fread(&data[i][j], 1, 1, fp);
		}
	}

	// رնȡļ
	fclose(fp);
}
//ıļ
void Image::WriteText(const char *filename)
{
	FILE* fp = NULL; // ļļָ
	fp = fopen(filename, "wb"); // д뷽ʽļ
	// дϢͷ
	fwrite(&bitmapinfoheader.biHeight, sizeof(bitmapinfoheader.biHeight), 1, fp);
	fwrite(&bitmapinfoheader.biWidth, sizeof(bitmapinfoheader.biWidth), 1, fp);
	// д
	for (int i = 0; i < bitmapinfoheader.biHeight; i++)
	{
		fwrite(data[i], bitmapinfoheader.biWidth * 3, 1, fp);
	}
	// رдļ
	fclose(fp);
}


//ȡͼֵָ
unsigned char& Image::At(int row, int col)
{
	return this->data[row * 3][col * 3];
}
//(row,col)Ϊĳֵ
void Image::Set(int row, int col, unsigned char value)
{
	//¶ȡ
	unsigned char** t_data = (unsigned char**)malloc(sizeof(unsigned char*) * bitmapinfoheader.biHeight);
	for (int i = 0; i < bitmapinfoheader.biHeight; i++)
	{
		t_data[i] = (unsigned char*)malloc(bitmapinfoheader.biWidth * 3);
		for (int j = 0; j < bitmapinfoheader.biWidth * 3; j++)
		{
			t_data[i][j] = data[i][j];
		}
	}
	//޸ֵ
	for (int i = 0; i < 3; i++)
	{
		t_data[row * 3 + i][col * 3 + i] = value;
	}
	//ͼ
	this->WriteBMP("setImg.bmp", t_data);
	myFree(t_data, bitmapinfoheader.biHeight);
}
//ͼΪͬһֵ
void Image::Set(unsigned char value) 
{
	//¶ȡ
	unsigned char** t_data = (unsigned char**)malloc(sizeof(unsigned char*) * bitmapinfoheader.biHeight);
	for (int i = 0; i < bitmapinfoheader.biHeight; i++)
	{
		t_data[i] = (unsigned char*)malloc(bitmapinfoheader.biWidth * 3);
		for (int j = 0; j < bitmapinfoheader.biWidth * 3; j++)
		{
			t_data[i][j] = data[i][j];
		}
	}
	//޸ֵ
	for (int i = 0; i < this->bitmapinfoheader.biHeight; i++)
	{
		for (int j = 0; j < this->bitmapinfoheader.biWidth * 3; j++)
		{
			t_data[i][j] = value;
		}
	}
	//ͼ
	this->WriteBMP("setAllImg.bmp", t_data);
	myFree(t_data, bitmapinfoheader.biHeight);
}


//false ңtrue 
void Image::Flip(int code)
{
	//¶ȡ
	unsigned char** t_data = (unsigned char**)malloc(sizeof(unsigned char*) * bitmapinfoheader.biHeight);
	for (int i = 0; i < bitmapinfoheader.biHeight; i++)
	{
		t_data[i] = (unsigned char*)malloc(bitmapinfoheader.biWidth * 3);
		for (int j = 0; j < bitmapinfoheader.biWidth * 3; j++)
		{
			t_data[i][j] = data[i][j];
		}
	}

	if (code)
	{
		//·תͼƬ
		for (int i = 0; i < bitmapinfoheader.biHeight / 2; i++)
		{
			unsigned char* temp = t_data[i];
			t_data[i] = t_data[bitmapinfoheader.biHeight - 1 - i];
			t_data[bitmapinfoheader.biHeight - 1 - i] = temp;
		}
		this->WriteBMP("flipImageUpDown.bmp",t_data);
	}
	else
	{
		//ҷתͼƬ
		for (int i = 0; i < bitmapinfoheader.biHeight; i++)
		{
			for (int j = 0; j < bitmapinfoheader.biWidth * 3 / 2; j += 3)
			{
				unsigned char temp = t_data[i][j];
				t_data[i][j] = t_data[i][bitmapinfoheader.biWidth * 3 - 1 - j - 2];
				t_data[i][bitmapinfoheader.biWidth * 3 - 1 - j - 2] = temp;

				unsigned char temp1 = t_data[i][j+1];
				t_data[i][j + 1] = t_data[i][bitmapinfoheader.biWidth * 3 - 1 - j - 1];
				t_data[i][bitmapinfoheader.biWidth * 3 - 1 - j - 1] = temp1;

				unsigned char temp2 = t_data[i][j + 2];
				t_data[i][j+2] = t_data[i][bitmapinfoheader.biWidth * 3 - 1 - j];
				t_data[i][bitmapinfoheader.biWidth * 3 - 1 - j] = temp2;
			}
		}
		this->WriteBMP("flipImageLeftRight.bmp",t_data);
	}

	this->myFree(t_data, this->bitmapinfoheader.biHeight);
}


//ͼСŴ
//falseС,trueŴ
void Image::Resize(int code)
{
	if (code)//Ŵ
	{
		/*	*
			*ѵҪڶĿƣ
			*ΪҪĸҪҵǶӦĹϵʽ
			*/
		unsigned char** t_data = (unsigned char**)malloc(sizeof(unsigned char*) * bitmapinfoheader.biHeight * 2);
		for (int i = 0; i < bitmapinfoheader.biHeight ; i++)
		{
			t_data[2 * i] = (unsigned char*)malloc(bitmapinfoheader.biWidth * 3 * 2);
			for (int j = 0; j < bitmapinfoheader.biWidth; j++)
			{
				t_data[2 * i][6 * j] = data[i][3 * j];
				t_data[2 * i][6 * j + 1] = data[i][3 * j + 1];
				t_data[2 * i][6 * j + 2] = data[i][3 * j + 2];

				t_data[2 * i][6 * j + 3] = data[i][3 * j];
				t_data[2 * i][6 * j + 3 + 1] = data[i][3 * j + 1];
				t_data[2 * i][6 * j + 3 + 2] = data[i][3 * j + 2];
			}

			t_data[2 * i + 1] = (unsigned char*)malloc(bitmapinfoheader.biWidth * 3 * 2);
			for (int j = 0; j < bitmapinfoheader .biWidth * 6; j++)
			{
				t_data[2 * i + 1][j] = t_data[2 * i][j];
			}
		}

		BMPFILEHEADER t_bmpfileheader = this->bmpfileheader;
		BITMAPINFOHEADER t_bitmapinfoheader = this->bitmapinfoheader;

		t_bitmapinfoheader.biHeight *= 2;
		t_bitmapinfoheader.biWidth *= 2;
		t_bitmapinfoheader.biSizeImage *= 4;

		this->WriteBMP("magnifyImage.bmp", t_data, t_bmpfileheader, t_bitmapinfoheader);
		this->myFree(t_data, t_bitmapinfoheader.biHeight);//ͷڴ
	}
	else//С
	{
		unsigned char** t_data = (unsigned char**)malloc(sizeof(unsigned char*) * bitmapinfoheader.biHeight / 2);
		for (int i = 0; i < bitmapinfoheader.biHeight / 2; i++)
		{
			t_data[i] = (unsigned char*)malloc(bitmapinfoheader.biWidth * 3 / 2);
			for (int j = 0, index = 0; j < bitmapinfoheader.biWidth / 2; j++)
			{
				t_data[i][index++] = data[2 * i][6 * j];
				t_data[i][index++] = data[2 * i][6 * j + 1];
				t_data[i][index++] = data[2 * i][6 * j + 2];
			}
		}

		BMPFILEHEADER t_bmpfileheader = this->bmpfileheader;
		BITMAPINFOHEADER t_bitmapinfoheader = this->bitmapinfoheader;

		t_bitmapinfoheader.biHeight /= 2;
		t_bitmapinfoheader.biWidth /= 2;
		t_bitmapinfoheader.biSizeImage /= 4;

		this->WriteBMP("shrinkImage.bmp", t_data, t_bmpfileheader, t_bitmapinfoheader);
		this->myFree(t_data, t_bitmapinfoheader.biHeight);//ͷڴ
	}
}


//ͼüĺ
void Image::Cut(int x1, int y1, int x2, int y2)
{//ü(x1,y1)(x2,y2)ͼ񡪡(0,120)  (512,360)  h = y2 - y1 = 240, w = x2 - x1 = 512
	if (x2 > x1 && y2 > y1)
	{
		int h = y2 - y1 + 1;
		int w = x2 - x1 + 1;
		while (w % 4)
		{
			w++;
		}
		//
		unsigned char **t_data = (unsigned char**)malloc(h * sizeof(unsigned char*));
		//m,nt_data±,i,jdata±
		for (int i = y1,m = 0; i <= y2; i++, m++)
		{
			t_data[m] = (unsigned char*)malloc(w * 3);
			memset(t_data[m],0, w * 3);
			for (int j = x1*3, n = 0; j <= x2*3 + 2; j++, n++)
			{
				t_data[m][n] = data[i][j];
			}
		}
		//ͷļ
		BMPFILEHEADER t_bmpfileheader = this->bmpfileheader;
		BITMAPINFOHEADER t_bitmapinfoheader = this->bitmapinfoheader;
		t_bitmapinfoheader.biHeight = h;
		t_bitmapinfoheader.biWidth = w;
		//ͨʽ¼biSize
		t_bitmapinfoheader.biSizeImage = (((w*t_bitmapinfoheader.biBitCount) + 31) / 32 * 4)*h;
		//
		WriteBMP("cutImage.bmp", t_data, t_bmpfileheader, t_bitmapinfoheader);
		//ͷ
		myFree(t_data, h);
	}
	else
	{
		puts("");
	}
}


//ͼתĺ
void Image::Rotate(int degree)//ͼתĺתǶΪ90ȵ
{
	BMPFILEHEADER t_bmpfileheader = this->bmpfileheader;
	BITMAPINFOHEADER t_bitmapinfoheader = this->bitmapinfoheader;
	if (degree == 90)
	{
		unsigned char** t_data = (unsigned char**)malloc(sizeof(unsigned char*) * bitmapinfoheader.biWidth);
		for (int i = 0; i < bitmapinfoheader.biWidth; i++)
		{
			t_data[i] = (unsigned char*)malloc(bitmapinfoheader.biHeight * 3);
			for (int j = 0; j < bitmapinfoheader.biHeight; j++)
			{
				t_data[i][j * 3] = data[bitmapinfoheader.biHeight - j - 1][3 * i];
				t_data[i][j * 3 + 1] = data[bitmapinfoheader.biHeight - j - 1][3 * i + 1];
				t_data[i][j * 3 + 2] = data[bitmapinfoheader.biHeight - j - 1][3 * i + 2];
			}
		}
		//дϢͷ
		t_bitmapinfoheader.biHeight = this->bitmapinfoheader.biWidth;
		t_bitmapinfoheader.biWidth = this->bitmapinfoheader.biHeight;
		//ͼƬ
		this->WriteBMP("rotate90.bmp", t_data, t_bmpfileheader, t_bitmapinfoheader);
		this->myFree(t_data, t_bitmapinfoheader.biHeight);
	}
	else if (degree == 180)
	{
		unsigned char** t_data = (unsigned char**)malloc(sizeof(unsigned char*) * bitmapinfoheader.biHeight);
		for (int i = 0; i < bitmapinfoheader.biHeight; i++)
		{
			t_data[i] = (unsigned char*)malloc(bitmapinfoheader.biWidth * 3);
			for (int j = 0; j < bitmapinfoheader.biWidth; j++)
			{
				t_data[i][j * 3] = data[bitmapinfoheader.biHeight - i - 1][bitmapinfoheader.biWidth * 3 - j * 3 - 3];
				t_data[i][j * 3 + 1] = data[bitmapinfoheader.biHeight - i - 1][bitmapinfoheader.biWidth * 3 - j * 3 - 3 + 1];
				t_data[i][j * 3 + 2] = data[bitmapinfoheader.biHeight - i - 1][bitmapinfoheader.biWidth * 3 - j * 3 - 3 + 2];
			}
		}
		//ͼƬ
		this->WriteBMP("rotate180.bmp", t_data);
		this->myFree(t_data, t_bitmapinfoheader.biHeight);
	}
	else if (degree == 270)
	{
		unsigned char** t_data = (unsigned char**)malloc(sizeof(unsigned char*) * bitmapinfoheader.biWidth);
		for (int i = 0; i < bitmapinfoheader.biWidth; i++)
		{
			t_data[i] = (unsigned char*)malloc(bitmapinfoheader.biHeight * 3);
			for (int j = 0; j < bitmapinfoheader.biHeight; j++)
			{
				t_data[i][j * 3] = data[j][bitmapinfoheader.biWidth * 3 - 3 -i * 3];
				t_data[i][j * 3 + 1] = data[j][bitmapinfoheader.biWidth * 3 - 3 - i * 3 + 1];
				t_data[i][j * 3 + 2] = data[j][bitmapinfoheader.biWidth * 3 - 3 - i * 3 + 2];
			}
		}
		//дϢͷ
		t_bitmapinfoheader.biHeight = this->bitmapinfoheader.biWidth;
		t_bitmapinfoheader.biWidth = this->bitmapinfoheader.biHeight;
		//ͼƬ
		this->WriteBMP("rotate270.bmp", t_data, t_bmpfileheader, t_bitmapinfoheader);
		this->myFree(t_data, t_bitmapinfoheader.biHeight);
	}
	else
	{
		puts("ĽǶȲҪ");
	}
}


//ֵ
void Image::Mean_Variance(float &m, float &var)//ͼľֵͷò
{
	float sum = 0;
	float ave = 0;
	float vSum = 0;
	float vAve = 0;
	for (int i = 0; i < bitmapinfoheader.biHeight; i++)
	{
		for (int j = 0; j < bitmapinfoheader.biWidth * 3; j++)
		{
			sum += this->data[i][j];
		}
	}
	ave = sum / (bitmapinfoheader.biHeight*bitmapinfoheader.biWidth * 3);
	for (int i = 0; i < bitmapinfoheader.biHeight; i++)
	{
		for (int j = 0; j < bitmapinfoheader.biWidth * 3; j++)
		{
			vSum += (data[i][j] - ave)*(data[i][j] - ave);
		}
	}
	vAve = vSum / (bitmapinfoheader.biHeight*bitmapinfoheader.biWidth * 3);

	m = ave;
	var = vAve;
}


Image& Image::operator=(Image& val)//ز
{
	this->bitmapinfoheader = val.bitmapinfoheader;
	this->bmpfileheader = val.bmpfileheader;
	this->height = val.height;
	this->width = val.width;
	// ̬ά洢ݣעһָ飬
	this->data = (unsigned char **)malloc(sizeof(unsigned char*) * bitmapinfoheader.biHeight);
	//СΪsizeof(unsigned char*) * bitmapinfoheader.biHeight״
	//ָ
	for (int i = 0; i < bitmapinfoheader.biHeight; i++)
	{
		//ע3ͨÿ3ֽ
		this->data[i] = (unsigned char *)malloc(bitmapinfoheader.biWidth * 3);
		// ȡ
		for (int j = 0; j < bitmapinfoheader.biWidth * 3; j++)
		{
			this->data[i][j] = val.data[i][j];
		}
	}

	return *this;
}


//ʵԪImage
void Swap(Image &a, Image &b)
{
	Image t(a);
	a = b;
	b = t;
}
